import java.util.*;
import java.io.*;

public class Main {
    static long k, num;
    static long[] squares;

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        k = sc.nextLong();
        squares = new long[2000_001];
        for (int i = 1; i < 2000_001; i++)
            squares[i] += squares[i - 1] + (i - 1) * 2 + 1;
        num = k;
        for (int i = 0; i < 2000_001; i++) {
            if(num < 0){
                num += i * 2 + 1;
                continue;
            }
            int l = 0;
            int r = 2000_001;
            while (l + 1 != r) {
                int m = (l + r) / 2;
                if (check(m))
                    r = m;
                else
                    l = m;
            }
            if (squares[l] == num) {
                System.out.println((int) Math.sqrt(num));
                return;
            }
            num += i * 2 + 1;
        }
        System.out.println("none");
    }

    public static boolean check(int m) {
        if (num >= squares[m])
            return false;
        return true;
    }
}
