import org.omg.CORBA.MARSHAL;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Random;
import java.util.StringTokenizer;

public class Solver {
    static BufferedReader br;
    static StringTokenizer st = new StringTokenizer("");
    static PrintWriter writer = new PrintWriter(System.out);

    public static String fstr() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public static int fs() throws IOException {
        return Integer.parseInt(fstr());
    }

    public static double fsd() throws IOException {
        return Double.parseDouble(fstr());
    }

    public static long fsl() throws IOException {
        return Long.parseLong(fstr());
    }

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        long k = fs();
        int sqre = 0;

        while(true){
            double d = Math.sqrt(k + sqre*sqre);
            int i = (int) d;
            if(d - i == 0){
                writer.println(i);
                break;
            }
            sqre++;
            if(i > 1000){
                writer.print("none");
            }
        }

        writer.close();
    }
}