#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;

bool comp (int a, int b){
    vector <int> az, bv;
    if (a % 10 == a) az.push_back(a);
    if (b % 10 == b) bv.push_back(b);
    while(a % 10 != a){
        az.push_back(a % 10); a/= 10;
    }
    while(b % 10 != b){
        bv.push_back(b % 10);
        b /= 10;
    }
    for (int i = 0; i < min(az.size(), bv.size()); i++){
        if (az[i] > bv[i]) return a < b;
    }
    return b < a;
}

int main() {
    int n;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    sort(a.begin(), a.end(), comp);
    for (int i = 0; i < n; i++){
        cout << a[i];
    }
    return 0;
}