import java.util.*;
import java.io.*;

public class Main {
    static int n;
    static num[] nums;
    static String ans;

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        n = sc.nextInt();
        nums = new num[n];
        ans = "";
        int maxSize = 0;
        for (int i = 0; i < n; i++) {
            int a = sc.nextInt();
            nums[i] = new num(a, size(a), a);
            maxSize = Math.max(maxSize, nums[i].size);
        }
        for (int i = 0; i < n; i++) {
            nums[i].num *= (10 * (maxSize - nums[i].size));
        }
        Arrays.sort(nums, new numsComparator());
        for (int i = 0; i < n; i++) {
            ans += nums[n - i - 1].newNum;
        }
        System.out.print(ans);
    }

    public static int size(int a) {
        int cnt = 0;
        while (a != 0) {
            a /= 10;
            cnt++;
        }
        return cnt;
    }
}

class num {
    int num;
    int size;
    int newNum;

    public num(int num, int size, int newNum) {
        this.num = num;
        this.size = size;
        this.newNum = newNum;
    }
}

class numsComparator implements Comparator<num> {
    public int compare(num o1, num o2) {
        return Integer.compare(o1.num, o2.num);
    }
}
