import java.util.*;
import java.io.*;

public class Main {
    static int n, ans;
    static int[] needs;

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        n = sc.nextInt();
        needs = new int[n];
        int podzadacha = 0;
        ans = 1;
        boolean check = true;
        for (int i = 0; i < n; i++) {
            needs[i] = sc.nextInt();
            if (i == 0 && needs[0] != -1)
                check = false;
            else if (needs[i] != i && i > 0)
                check = false;
        }
        if (check)
            podzadacha = 2;
        if (podzadacha == 2) {
            System.out.println((n + 1) / 2);
            return;
        }
        if (n <= 20)
            podzadacha = 1;
        boolean[] used = new boolean[n];
        if (podzadacha == 1) {
            rec(used, 0, 0);
            System.out.print(ans);
            return;
        }
        rep[] rep = new rep[n];
        for (int i = 0; i < n; i++)
            rep[i] = new rep(0, i);
        for (int i = 0; i < n; i++) {
            if (needs[i] != -1)
                rep[needs[i] - 1].rep++;
        }
        Arrays.sort(rep, new repComparator());
        for (int i = 0; i < n; i++) {
            if (check(used)) {
                System.out.print(n - i - 1);
                return;
            }
            used[rep[i].num - 1] = false;
        }
    }

    public static boolean check(boolean[] used) {
        for (int i = 0; i < n; i++) {
            if ((needs[i] != -1 && used[needs[i] - 1] && used[i]))
                return false;
        }
        return true;
    }

    public static void rec(boolean used[], int i, int cnt) {
        if (i == n) {
            if (check(used))
                ans = Math.max(ans, cnt);
            return;
        }
        used[i] = true;
        rec(used, i + 1, cnt + 1);
        used[i] = false;
        rec(used, i + 1, cnt);
    }
}

class rep {
    int rep, num;

    public rep(int rep, int num) {
        this.rep = rep;
        this.num = num;
    }
}

class repComparator implements Comparator<rep> {
    public int compare(rep o1, rep o2) {
        return Integer.compare(o2.rep, o1.rep);
    }
}