
import java.io.*;
import java.util.*;

public class s {
    int n;
    ArrayList<Integer> arr[];
    boolean used[];

    void dfs(int v) {
        used[v] = true;
        for (int i = 0; i < arr[v].size(); i++) {
            if (!used[arr[v].get(i)]) {
                dfs(arr[v].get(i));
            }
        }
    }

    private void solve() throws IOException {
        n = nextInt();
        arr = new ArrayList[n];
        for (int i = 0; i < n; i++) {
            arr[i] = new ArrayList<>();
        }
        used = new boolean[n];
        Arrays.fill(used, false);
        for (int i = 0; i < n; i++) {
            int x = nextInt() - 1;
            if (x != -2) {
                arr[i].add(x);
                arr[x].add(i);
            }
        }
        int ans = 1;
        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                dfs(i);
                ans++;
            }
        }
        System.out.println(ans);


    }

    private void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new s().run();
    }

}