import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.util.Comparator;
import java.util.Arrays;

public class Solver {
    static BufferedReader br;
    static StringTokenizer st = new StringTokenizer("");
    static PrintWriter writer = new PrintWriter(System.out);
    public static String fstr() throws IOException {
        while (!st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public static int fs() throws IOException {
        return Integer.parseInt(fstr());
    }

    public static double fsd() throws IOException {
        return Double.parseDouble(fstr());
    }

    public static long fsl() throws IOException {
        return Long.parseLong(fstr());
    }


    public static void main(String[] args) throws IOException{
        br = new BufferedReader(new InputStreamReader(System.in));
        int n = fs();

        Element[] arr = new Element[n];
        for (int i = 0; i < n; i++) {
            arr[i] = new Element();
            String str = fstr();
            char[] chArr = str.toCharArray();
            if(chArr.length >= 1){
                arr[i].a = chArr[0] - '0';
                if(chArr.length >= 2){
                    arr[i].b = chArr[1] - '0';
                    if(chArr.length >= 3){
                        arr[i].c = chArr[2] - '0';
                        if(chArr.length >= 4){
                            arr[i].d = chArr[3] - '0';
                            if(chArr.length >= 5){
                                arr[i].e = chArr[4] - '0';
                                if(chArr.length >= 6){
                                    arr[i].f = chArr[5] - '0';
                                    if(chArr.length >= 7){
                                        arr[i].g = chArr[6] - '0';
                                    }
                                }
                            }
                        }
                    }
                }
            }
            if(chArr.length <= 6){
                arr[i].g = 5;
                if(chArr.length <= 5){
                    arr[i].f = 5;
                    if(chArr.length <= 4){
                        arr[i].e = 5;
                        if(chArr.length <= 3){
                            arr[i].d = 5;
                            if(chArr.length <= 2){
                                arr[i].c = 5;
                                if(chArr.length <= 1){
                                    arr[i].b = 5;
                                }
                            }
                        }
                    }
                }
            }
            arr[i].n = chArr.length;
        }


        Arrays.sort(arr, new Comparator<Element>() {
            @Override
            public int compare(Element o1, Element o2) {
                if(o1.a == o2.a){
                    if(o1.b == o2.b){
                        if(o1.c == o2.c){
                            if(o1.d == o2.d){
                                if(o1.e == o2.e){
                                    if(o1.f == o2.f){
                                        if(o1.g == o2.g){
                                            return Integer.compare(o1.g, o2.g);
                                        }
                                        return Integer.compare(o1.f, o2.f);
                                    }
                                }
                                return Integer.compare(o1.e, o2.e);
                            }
                            return Integer.compare(o1.d, o2.d);
                        }
                        return Integer.compare(o1.c, o2.c);
                    }
                    return Integer.compare(o1.b, o2.b);
                }
                return Integer.compare(o1.a, o2.a);
            }
        });
        String ans = "";
        for (int i = n - 1; i >= 0; i--) {
            if(arr[i].n >= 1){
                ans += String.valueOf(arr[i].a);
                if(arr[i].n >= 2){
                    ans += String.valueOf(arr[i].b);
                    if(arr[i].n >= 3){
                        ans += String.valueOf(arr[i].c);
                        if(arr[i].n >= 4){
                            ans += String.valueOf(arr[i].d);
                            if(arr[i].n >= 5){
                                ans += String.valueOf(arr[i].e);
                                if(arr[i].n >= 6){
                                    ans += String.valueOf(arr[i].f);
                                    if(arr[i].n >= 7){
                                        ans += String.valueOf(arr[i].g);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        writer.println(ans);
        writer.close();
    }

}
class Element{
    int a, b, c, d, e, f, g, n;
}