#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll MOD = 1000000007;

vector<vector<ll> > r;
vector<vector<ll> > unr;
vector<int> used;
deque<ll> tp;

void dfsTOP(ll u){
    used[u] = 1;
    for(auto i : r[u])
        if(!used[i])
            dfsTOP(i);
    tp.push_back(u);
}

int dfs(int u, bool a){
    used[u] = 2;
    int sum = 0;
    bool take = 0;
    for(auto i : r[u]){
        if(!used[i])
            sum += dfs(i, !a);
        else if(used[i] == 2){
            used[u] = 1;
            return 0;
        }
    }
    used[u] = 1;
    return sum + a;
}

int main()
{
    ll n;
    cin >> n;
    r.resize(n);
    unr.resize(n);
    used.resize(n);
    for(ll i = 0; i < n; i++){
        ll y;
        cin >> y;
        if(y != -1){
            unr[y - 1].push_back(i);
            r[i].push_back(y - 1);
        }
    }
    for(ll i = 0; i < n; i++){
        if(!used[i]){
            dfsTOP(i);
        }
    }
    fill(used.begin(), used.end(), 0);
    ll k = 0;
    ll _k = 0;
    for(ll i = n - 1; i >= 0; i--){
        if(!used[tp[i]]){
            used[tp[i]] = 1;
            k += dfs(tp[i], 1);
        }
    }
    cout << std::max(k, _k);
}
