import javafx.scene.transform.Scale;

import java.io.PrintWriter;
import java.security.acl.LastOwnerException;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        PrintWriter pw = new PrintWriter(System.out);
        int n = sc.nextInt();
        num[]a= new num[n];
        for (int i = 0; i < n; i++) {
            int b = sc.nextInt();
            a[i]= new num( b);
        }
        Arrays.sort(a,new numComporator());
        for (int i = 0; i < n; i++) {
            pw.print(a[i].number);
        }
        pw.close();
    }

}
class num{
    int number;
    public num(int number) {
        this.number = number;
    }
}
class numComporator implements Comparator<num>{
    @Override
    public int compare(num o1, num o2) {
        String a1 = o1.number+"";
        String a2 = o2.number+"";
        long aa = Long.parseLong(a1+a2);
        long bb = Long.parseLong(a2+a1);
        return -Long.compare(aa,bb);
    }
}