import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class Main {
    private static BufferedReader br;
    private static StringTokenizer st = new StringTokenizer("");

    private static double nextDouble() throws IOException {
        while (!st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return Double.parseDouble(st.nextToken());
    }

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter pw = new PrintWriter(System.out);
        double n = nextDouble();
        if (n%4==2){
            pw.print("none");
            pw.close();
            return;
        }
        long cnt = 0;
        double h = 0;
        while (cnt <= Long.MAX_VALUE) {
            if (Math.sqrt(n + h * h) - (long) Math.sqrt(n + h * h) == 0) {
                pw.print((long) Math.sqrt(n+h*h));
                pw.close();
                return;
            }
            h++;
            cnt++;
        }
    }
}