import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class Main {
    static BufferedReader br;
    static StringTokenizer st = new StringTokenizer("");

    static double nextDouble() throws IOException {
        while (!st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return Double.parseDouble(st.nextToken());
    }

    static int nextInt() throws IOException {
        while (!st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return Integer.parseInt(st.nextToken());
    }

    static long nextLong() throws IOException {
        while (!st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return Long.parseLong(st.nextToken());
    }

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter pw = new PrintWriter(System.out);
        int n = nextInt();
        int m = nextInt();
        int FirstArray[] = new int[n];
        int SecondArray[] = new int[m];
        for (int i = 0; i < n; i++) {
            FirstArray[i] = nextInt();
        }
        for (int i = 0; i < m; i++) {
            SecondArray[i] = nextInt();
        }
        if (FirstArray[1] == SecondArray[n - 1] && FirstArray[n - 1] == SecondArray[1]) {
            pw.println(2 * n - 1);
            for (int i = 0; i < n - 1; i++) {
                pw.print(SecondArray[i] + " ");
            }
            for (int i = 0; i < n; i++) {
                pw.print(n + " ");
            }
            pw.close();
            return;
        }
        pw.println(n);
        for (int i = n - 1; i >= 0; i--) {
            pw.print(n + " ");
        }
        pw.close();
    }
}