import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class Solver {
    static BufferedReader br;
    static StringTokenizer st = new StringTokenizer("");
    static PrintWriter writer = new PrintWriter(System.out);

    public static String fstr() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public static int fs() throws IOException {
        return Integer.parseInt(fstr());
    }

    public static double fsd() throws IOException {
        return Double.parseDouble(fstr());
    }

    public static long fsl() throws IOException {
        return Long.parseLong(fstr());
    }

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        int l = fs();
        int r = fs();
        int a = fs();
        int y = r % a;
        long count = y * ((r-l) / a);

        int x = y;
        while(r - l - x >= a){
            count += a * ((r - l - x) / a);
            x+=a;
        }


        writer.print(count);
        writer.close();
    }
}
