import java.lang.reflect.Array;
import java.util.*;
import java.io.*;

public class Main {

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        nums[] nums = new nums[n];
        for (int i = 0; i < n; i++) {
            int a = sc.nextInt();
            int[] a1 = convert(a);
            nums[i] = new nums(a1[0], a1[1], a1[2], a1[3], a1[4], a1[5], a1[6], a);
        }
        Arrays.sort(nums, new numsComparator());
        String ans = "";
        for (int i = 0; i < n; i++)
            ans += nums[n - i - 1].num;
        System.out.print(ans);
    }

    public static int[] convert(int a) {
        int[] ret = new int[7];
        Arrays.fill(ret, 10);
        int size = (a + "").length();
        for (int i = 0; i < size; i++) {
            ret[size - i - 1] = a % 10;
            a /= 10;
        }
        return ret;
    }
}

class nums {
    int num1, num2, num3, num4, num5, num6, num7, num;

    public nums(int num1, int num2, int num3, int num4, int num5, int num6, int num7, int num) {
        this.num1 = num1;
        this.num2 = num2;
        this.num3 = num3;
        this.num4 = num4;
        this.num5 = num5;
        this.num6 = num6;
        this.num7 = num7;
        this.num = num;
    }
}

class numsComparator implements Comparator<nums> {
    public int compare(nums o1, nums o2) {
        if (o1.num1 == o2.num1) {
            if (o1.num2 == o2.num2) {
                if (o1.num3 == o2.num3) {
                    if (o1.num4 == o2.num4) {
                        if (o1.num5 == o2.num5) {
                            if (o1.num6 == o2.num6)
                                return Integer.compare(o1.num7, o2.num7);
                            return Integer.compare(o1.num6, o2.num6);
                        }
                        return Integer.compare(o1.num5, o2.num5);
                    }
                    return Integer.compare(o1.num4, o2.num4);
                }
                return Integer.compare(o1.num3, o2.num3);
            }
            return Integer.compare(o1.num2, o2.num2);
        }
        return Integer.compare(o1.num1, o2.num1);
    }
}