import java.util.*;
import java.io.*;

public class Main {

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        nums[] nums = new nums[n];
        for (int i = 0; i < n; i++)
            nums[i] = new nums(sc.nextInt());
        Arrays.sort(nums, new numsComparator());
        String ans = "";
        for (int i = 0; i < n; i++)
            ans += nums[n - i - 1].num;
        System.out.print(ans);
    }
}

class nums {
    int num;

    public nums(int num) {
        this.num = num;
    }
}

class numsComparator implements Comparator<nums> {
    public int compare(nums o1, nums o2) {
        String w1 = (o1.num + "") + (o2.num + "");
        String w2 = (o1.num + "") + (o2.num + "");
        int y1 = Integer.parseInt(w1);
        int y2 = Integer.parseInt(w2);
        return Integer.compare(y1, y2);
    }
}