import java.util.*;
import java.io.*;

public class Main {

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        int k = sc.nextInt();
        if (n == k) {
            System.out.print(1);
            return;
        }
        int[][] dpU = new int[n + 1][n + 1];
        int[][] dpD = new int[n + 1][n + 1];
        dpU[k][k] = 1;
        dpD[k][k] = 1;
        for (int i = k; i <= n; i++) {
            for (int j = 1; j <= n; j++) {
                if (dpU[i][j] != 0) {
                    for (int l = 1; l < j && i + l <= n; l++) {
                        dpD[i + l][l] += dpU[i][j];
                    }
                }
                if (dpD[i][j] != 0) {
                    for (int l = j + 1; i + l <= n; l++) {
                        dpU[i + l][l] += dpD[i][j];
                    }
                }
            }
        }
        long ans = 0;
        for (int i = 0; i <= n; i++)
            ans += dpD[n][i] + dpU[n][i];
        System.out.print(ans);
    }
}