import javafx.util.Pair;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

public class Main {

    public static void main(String[] args) {
        Scanner in = new Scanner(new BufferedInputStream(System.in));
        PrintWriter out = new PrintWriter(new BufferedOutputStream(System.out));
        int n = in.nextInt();
        int[]  a= new int[n];
        Pair<Integer, Integer>[] m = new Pair[n];
        for (int i = 0; i < n; i++) {
            a[i] = in.nextInt();
            String s= "" + a[i];
            m[i] = new Pair<>((int)(a[i] * Math.pow(10, (7- s.length()))), i);
        }

        Arrays.sort(m, new Comparator<Pair<Integer, Integer>>() {
            @Override
            public int compare(Pair<Integer, Integer> o1, Pair<Integer, Integer> o2) {
                if(o1.getKey() > o2.getKey()){
                    return -1;
                }else if(o1.getKey() < o2.getKey()){
                    return 1;
                }else{
                    return 0;
                }
            }
        });

        for (int i = 0; i < n; i++) {
            out.print(a[m[i].getValue()]);
        }

        out.close();
    }
}
