import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

public class Main {

    public static void main(String[] args) {
        Scanner in = new Scanner(new BufferedInputStream(System.in));
        PrintWriter out = new PrintWriter(new BufferedOutputStream(System.out));
        int n = in.nextInt();
        char[][] a = new char[n][100000];


        for (int i = 0; i < n; i++) {
            char[] q = in.next().toCharArray();
            for (int j = 0; j < q.length; j++) {
                a[i][j] = q[j];
            }
            for (int j = q.length; j < 100000; j++) {
                a[i][j] = 18;
            }
        }
        Arrays.sort(a, new Comparator<char[]>() {
            @Override
            public int compare(char[] o1, char[] o2) {
                int j =0;
                char[] min = o1;
                char[] max = o2;
                for (int i = 0; i < Math.min(o1.length, o2.length); i++) {
                    if(o1[i] != 18 && o2[i] != 18) {
                        j ++;
                        if (o1[i] > o2[i]) {
                            return 1;
                        }else if(o1[i] < o2[i]){
                            return -1;
                        }
                    }else{
                        if(o1[i] == 18){
                            min = o1;
                            max = o2;
                        }else{
                            min = o2;
                            max = o1;
                        }
                        break;
                    }
                }
                for (int i = j; i < o1.length; i++) {
                    if(max[i] != 18){
                        if(max[i] > min[0]){
                            if(max == o1) {
                                return 1;
                            }else{
                                return -1;
                            }
                        }else if(max[i] < min[0]){
                            if(max == o1) {
                                return -1;
                            }else{
                                return 1;
                            }
                        }
                    }else{
                        return 0;
                    }
                }
                return 0;
            }
        });

        for (int i = n - 1; i >= 0 ; i--) {
            for (int j = 0; j < 100000; j++) {
                if(a[i][j] != 18){
                    out.print(a[i][j]);
                }else{
                    break;
                }
            }
        }
        out.close();
    }
}
