import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.util.Comparator;

public class Solver {
    static BufferedReader br;
    static StringTokenizer st = new StringTokenizer("");
    static PrintWriter writer = new PrintWriter(System.out);
    public static String fstr() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public static int fs() throws IOException {
        return Integer.parseInt(fstr());
    }

    public static double fsd() throws IOException {
        return Double.parseDouble(fstr());
    }

    public static long fsl() throws IOException {
        return Long.parseLong(fstr());
    }

    static int count = 0;
    public static void main(String[] args) throws IOException{
        br = new BufferedReader(new InputStreamReader(System.in));
        int n = fs();
        int k = fs();
        if(n == k) {
            writer.print(1);
            writer.close();
            return;
        }
        boolean b = true;
        recursion((n - k), k, b);
        b = false;
        recursion((n - k), k, b);
        writer.print(count);
        writer.close();
    }
    public static void recursion(int ost, int a, boolean menshe){
        if(ost == 0){
            count += 1;
            return;
        }
        if(menshe == true){
            menshe = false;
            for (int i = 1; i < a && i <= ost; i++) {
                recursion(ost - i, i, menshe);
            }
        }
        else{
            menshe = true;
            for (int i = a + 1; i <= ost; i++) {
                recursion(ost - i, i, menshe);
            }
        }

    }
}

