#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll MOD = 1000000007;

vector<vector<ll> > r;
vector<vector<ll> > unr;
vector<bool> used;
deque<ll> tp;

bool comp(ll a, ll b){
    return r[a].size() < r[b].size();
}

void dfsTOP(ll u){
    used[u] = 1;
    for(auto i : r[u])
        if(!used[i])
            dfsTOP(i);
    tp.push_back(u);
}

int main()
{
    ll n;
    cin >> n;
    r.resize(n);
    unr.resize(n);
    used.resize(n);
    for(ll i = 0; i < n; i++){
        ll y;
        cin >> y;
        if(y != -1){
            r[y - 1].push_back(i);
            unr[i].push_back(y - 1);
        }
    }
    for(ll i = 0; i < n; i++){
        if(!used[i]){
            dfsTOP(i);
        }
    }
    fill(used.begin(), used.end(), 0);
    ll k = 0;
    ll _k = 0;
    sort(tp.begin(), tp.end(), comp);
    for(int i = 0; i < n; i++){
        if(!used[tp[i]]){
            used[tp[i]] = 1;
            k++;
            for(auto j : r[tp[i]])
                used[j] = 1;
            for(auto j : unr[tp[i]])
                used[j] = 1;
        }
    }
    cout << std::max(k, _k);
}
