import javafx.scene.transform.Scale;

import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        PrintWriter pw = new PrintWriter(System.out);
        int n = sc.nextInt();
        num[] a = new num[n];
        for (int i = 0; i < n; i++) {
            int b= sc.nextInt();
            a[i]= new num(b,getfirst(b));
        }
        Arrays.sort(a,new numComporator());
        String ans = "";
        for (int i = 0; i<n; i++) {
            ans = ans + a[i].number;
        }
        pw.println(ans);
        pw.close();
    }
    public static int getfirst(int a){
        String s = ""+a;
        return Integer.parseInt(s.substring(0,1));
    }
}
class num{
    int number,first;

    public num(int number,int first) {
        this.number = number;
        this.first = first;

    }
}
class numComporator implements Comparator<num>{
    @Override
    public int compare(num o1,num o2) {
        String a1 = ""+ o1.number;
        String a2 = ""+o2.number;
        if (o1.first==o2.first){
            for (int i = 1; i <Math.min(a1.length(),a2.length()) ; i++) {
                if (a1.charAt(i)!=a2.charAt(i)){
                    return -Integer.compare(a1.charAt(i),a2.charAt(i));
                }else {
                    continue;
                }
            }
            return Integer.compare(a1.length(),a2.length());
        }
        else {
           return -Integer.compare(o1.first,o2.first);
        }
    }
}
