#include <bits/stdc++.h>

using namespace std;

vector < vector < int > > G;
vector < int > used;

int step = 0;

void dfs(int v){
    used[v] = step % 2 + 1;
    for (int i = 0; i < G[v].size(); i++){
        int to = G[v][i];
        if (used[to] == 0){
            step++;
            dfs(to);
        }else{
            if (used[to] == 1 && step == 0)
                used[v] = 1 + 1;
            else if (used[to] == 2 && step == 0)
                used[v] = 1;
            else
                used[v] = 3;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    int n, a;
    cin >> n;
    used.resize(n);
    G.resize(n);
    for (int i = 0; i < n; i++){
        cin >> a;
        if (a != -1)
            G[i].push_back(a - 1);
    }
    for (int i = 0; i < n; i++){
        step = 0;
        if (used[i] == 0){
            dfs(i);
        }
    }
    int fst = 0, snd = 0;
    for (int i = 0; i < n; i++){
        if (used[i] == 1)
            fst++;
        else if (used[i] == 2)
            snd++;
    }
    cout << max(snd, fst);
}
